// MsgQueue.cpp : Implementation of CMsgQueue
#include "stdafx.h"
#include "AtlQueue.h"
#include "MsgQueue.h"
#define DEBUG_PRINT
//#undef DEBUG_PRINT


typedef CComEnum<IEnumConnectionPoints,
	&IID_IEnumConnectionPoints, IConnectionPoint*,
	_CopyInterface<IConnectionPoint> >
	CComEnumConnectionPoints;

/////////////////////////////////////////////////////////////////////////////
// CMsgQueue

CMsgQueue::CMsgQueue() 
{
}

STDMETHODIMP CMsgQueue::InterfaceSupportsErrorInfo(REFIID riid)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	static const IID* arr[] = 
	{
		&IID_IMsgQueue
	};
	for (int i=0; i < sizeof(arr) / sizeof(arr[0]); i++)
	{
		if (InlineIsEqualGUID(*arr[i],riid))
			return S_OK;
	}
	return S_FALSE;
}

STDMETHODIMP CMsgQueue::PostMessage(short portNo)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

#ifdef DEBUG_PRINT
	AfxMessageBox("COM: message received");
#endif
	Fire_OnNewMessage(portNo);

	return S_OK;
}


// Override this method to add another check for IDispatch when Progress is calling this method!
STDMETHODIMP CMsgQueue::Advise(IUnknown *pUnk, DWORD *pdwCookie)
{
#ifdef DEBUG_PRINT
	AfxMessageBox("In Advise()");
#endif

	//OK. This function is the important one. This is the place
    //where we store event sink object for future reference.
    HRESULT hr = E_UNEXPECTED;
   
    //First we need to make sure that our pointers are valid.
    if (0 == pUnk) return E_POINTER;
   
    if (0 == pdwCookie) return E_POINTER;



	_IMsgQueueEvents *pEvt = 0;
	int type = 0;
       
    hr = pUnk->QueryInterface(__uuidof(_IMsgQueueEvents), (void **)&pEvt);
    if (SUCCEEDED(hr))
    {
#ifdef DEBUG_PRINT
		AfxMessageBox("Advise()--> sink is IMsgQueueEvents");
#endif
		type = 1;
    }
    else // Workaround for Progress, which doesn't implement the event source, but simply provides IDispatch
    {
#ifdef DEBUG_PRINT
		AfxMessageBox("No");
#endif
	    hr = pUnk->QueryInterface(__uuidof(IDispatch), (void **)&pEvt);

		if (SUCCEEDED(hr))
		{
#ifdef DEBUG_PRINT
			AfxMessageBox("Advise()--> sink is IDispatch (how do we trust this?)");
#endif
			type = 2;
		}
		else
		{
#ifdef DEBUG_PRINT
			AfxMessageBox("Advise()--> sink is invalid");
#endif	
			return CONNECT_E_CANNOTCONNECT;
		}
    }

	Lock();
	*pdwCookie = m_vec.Add(pUnk);
	hr = (*pdwCookie != NULL) ? S_OK : CONNECT_E_ADVISELIMIT;
	Unlock();

	if (hr != S_OK)
		pUnk->Release();
	if (FAILED(hr))
		*pdwCookie = 0;

	return hr;
}

